package main

import (
	"octopus/cmd/octopus/scripts"
	"octopus/cmd/octopus/server"
	"octopus/internal/config"
	"octopus/internal/dal"
	"octopus/internal/dal/query"

	"github.com/casdoor/casdoor-go-sdk/casdoorsdk"
	"github.com/rs/zerolog/log"

	"github.com/spf13/cobra"
)

var rootCmd = &cobra.Command{
	Use:   "octopus-cli",
	Short: "The `octopus` CLI",
}

func main() {
	rootCmd.AddCommand(server.CmdRun)
	rootCmd.AddCommand(scripts.CmdScripts)
	db := dal.GetPostgres()

	// migrations.Migrate(db)

	query.SetDefault(db)
	if err := rootCmd.Execute(); err != nil {
		log.Fatal().Err(err).Msg("Failed to execute root command")
	}
}

func init() {
	c := config.Get().Casdoor
	casdoorsdk.InitConfig(c.Endpoint, c.ClientID, c.ClientSecret, c.Certificate, c.OrganizationName, c.AppName)
}
